Index: drivers/filesystems/btrfs/balance.c
===================================================================
--- drivers/filesystems/btrfs/balance.c	(révision 75772)
+++ drivers/filesystems/btrfs/balance.c	(copie de travail)
@@ -2625,164 +3123,279 @@
             ExReleaseResourceLite(&c->lock);
             break;
         }
-        
+
         if ((!(Vcb->balance.opts[sort].flags & BTRFS_BALANCE_OPTS_LIMIT) || num_chunks[sort] < Vcb->balance.opts[sort].limit_end) &&
             should_balance_chunk(Vcb, sort, c)) {
-            c->reloc = TRUE;
-            
             InsertTailList(&chunks, &c->list_entry_balance);
-            
+
             num_chunks[sort]++;
             Vcb->balance.total_chunks++;
+            Vcb->balance.chunks_left++;
+        } else if (sort == BALANCE_OPTS_METADATA)
+            okay_metadata_chunks++;
+        else if (sort == BALANCE_OPTS_DATA)
+            okay_data_chunks++;
+        else if (sort == BALANCE_OPTS_SYSTEM)
+            okay_system_chunks++;
+
+        if (!c->cache_loaded) {
+            Status = load_cache_chunk(Vcb, c, NULL);
+
+            if (!NT_SUCCESS(Status)) {
+                ERR("load_cache_chunk returned %08x\n", Status);
+                Vcb->balance.status = Status;
+                ExReleaseResourceLite(&c->lock);
+                ExReleaseResourceLite(&Vcb->chunk_lock);
+                goto end;
+            }
         }
-        
+
         ExReleaseResourceLite(&c->lock);
-        
+
         le = le->Flink;
     }
-    
+
     ExReleaseResourceLite(&Vcb->chunk_lock);
-    
-    Vcb->balance.chunks_left = Vcb->balance.total_chunks;
-    
+
+    // If we're doing a full balance, try and allocate a new chunk now, before we mess things up
+    if (okay_metadata_chunks == 0 || okay_data_chunks == 0 || okay_system_chunks == 0) {
+        BOOL consolidated = FALSE;
+        chunk* c;
+
+        if (okay_metadata_chunks == 0) {
+            ExAcquireResourceExclusiveLite(&Vcb->chunk_lock, TRUE);
+
+            Status = alloc_chunk(Vcb, Vcb->metadata_flags, &c, TRUE);
+            if (NT_SUCCESS(Status))
+                c->balance_num = Vcb->balance.balance_num;
+            else if (Status != STATUS_DISK_FULL || consolidated) {
+                ERR("alloc_chunk returned %08x\n", Status);
+                ExReleaseResourceLite(&Vcb->chunk_lock);
+                Vcb->balance.status = Status;
+                goto end;
+            }
+
+            ExReleaseResourceLite(&Vcb->chunk_lock);
+
+            if (Status == STATUS_DISK_FULL) {
+                Status = try_consolidation(Vcb, Vcb->metadata_flags, &c);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("try_consolidation returned %08x\n", Status);
+                    Vcb->balance.status = Status;
+                    goto end;
+                } else
+                    c->balance_num = Vcb->balance.balance_num;
+
+                consolidated = TRUE;
+
+                if (Vcb->balance.stopping)
+                    goto end;
+            }
+        }
+
+        if (okay_data_chunks == 0) {
+            ExAcquireResourceExclusiveLite(&Vcb->chunk_lock, TRUE);
+
+            Status = alloc_chunk(Vcb, Vcb->data_flags, &c, TRUE);
+            if (NT_SUCCESS(Status))
+                c->balance_num = Vcb->balance.balance_num;
+            else if (Status != STATUS_DISK_FULL || consolidated) {
+                ERR("alloc_chunk returned %08x\n", Status);
+                ExReleaseResourceLite(&Vcb->chunk_lock);
+                Vcb->balance.status = Status;
+                goto end;
+            }
+
+            ExReleaseResourceLite(&Vcb->chunk_lock);
+
+            if (Status == STATUS_DISK_FULL) {
+                Status = try_consolidation(Vcb, Vcb->data_flags, &c);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("try_consolidation returned %08x\n", Status);
+                    Vcb->balance.status = Status;
+                    goto end;
+                } else
+                    c->balance_num = Vcb->balance.balance_num;
+
+                consolidated = TRUE;
+
+                if (Vcb->balance.stopping)
+                    goto end;
+            }
+        }
+
+        if (okay_system_chunks == 0) {
+            ExAcquireResourceExclusiveLite(&Vcb->chunk_lock, TRUE);
+
+            Status = alloc_chunk(Vcb, Vcb->system_flags, &c, TRUE);
+            if (NT_SUCCESS(Status))
+                c->balance_num = Vcb->balance.balance_num;
+            else if (Status != STATUS_DISK_FULL || consolidated) {
+                ERR("alloc_chunk returned %08x\n", Status);
+                ExReleaseResourceLite(&Vcb->chunk_lock);
+                Vcb->balance.status = Status;
+                goto end;
+            }
+
+            ExReleaseResourceLite(&Vcb->chunk_lock);
+
+            if (Status == STATUS_DISK_FULL) {
+                Status = try_consolidation(Vcb, Vcb->system_flags, &c);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("try_consolidation returned %08x\n", Status);
+                    Vcb->balance.status = Status;
+                    goto end;
+                } else
+                    c->balance_num = Vcb->balance.balance_num;
+
+                consolidated = TRUE;
+
+                if (Vcb->balance.stopping)
+                    goto end;
+            }
+        }
+    }
+
+    ExAcquireResourceSharedLite(&Vcb->chunk_lock, TRUE);
+
+    le = chunks.Flink;
+    while (le != &chunks) {
+        chunk* c = CONTAINING_RECORD(le, chunk, list_entry_balance);
+
+        c->reloc = TRUE;
+
+        le = le->Flink;
+    }
+
+    ExReleaseResourceLite(&Vcb->chunk_lock);
+
     // do data chunks before metadata
     le = chunks.Flink;
     while (le != &chunks) {
         chunk* c = CONTAINING_RECORD(le, chunk, list_entry_balance);
         LIST_ENTRY* le2 = le->Flink;
-        
+
         if (c->chunk_item->type & BLOCK_FLAG_DATA) {
-            NTSTATUS Status;
             BOOL changed;
-            
+
             do {
                 changed = FALSE;
-                
-                FsRtlEnterFileSystem();
-                
+
                 Status = balance_data_chunk(Vcb, c, &changed);
-                
-                FsRtlExitFileSystem();
-                
                 if (!NT_SUCCESS(Status)) {
                     ERR("balance_data_chunk returned %08x\n", Status);
                     Vcb->balance.status = Status;
                     goto end;
                 }
-                
+
                 KeWaitForSingleObject(&Vcb->balance.event, Executive, KernelMode, FALSE, NULL);
-                
+
+                if (Vcb->readonly)
+                    Vcb->balance.stopping = TRUE;
+
                 if (Vcb->balance.stopping)
                     break;
             } while (changed);
-        
-            if (!c->list_entry_changed.Flink)
-                InsertTailList(&Vcb->chunks_changed, &c->list_entry_changed);
+
+            c->changed = TRUE;
+            c->space_changed = TRUE;
         }
-            
-        if (Vcb->balance.stopping) {
-            while (le != &chunks) {
-                c = CONTAINING_RECORD(le, chunk, list_entry_balance);
-                c->reloc = FALSE;
-                
-                le = le->Flink;
-            }
+
+        if (Vcb->balance.stopping)
             goto end;
-        }
-        
+
         if (c->chunk_item->type & BLOCK_FLAG_DATA &&
             (!(Vcb->balance.opts[BALANCE_OPTS_METADATA].flags & BTRFS_BALANCE_OPTS_ENABLED) || !(c->chunk_item->type & BLOCK_FLAG_METADATA))) {
             RemoveEntryList(&c->list_entry_balance);
             c->list_entry_balance.Flink = NULL;
-            
+
             Vcb->balance.chunks_left--;
         }
-        
+
         le = le2;
     }
-    
+
     // do metadata chunks
     while (!IsListEmpty(&chunks)) {
         chunk* c;
-        NTSTATUS Status;
         BOOL changed;
-        
+
         le = RemoveHeadList(&chunks);
         c = CONTAINING_RECORD(le, chunk, list_entry_balance);
-        
+
         if (c->chunk_item->type & BLOCK_FLAG_METADATA || c->chunk_item->type & BLOCK_FLAG_SYSTEM) {
             do {
-                FsRtlEnterFileSystem();
-                
                 Status = balance_metadata_chunk(Vcb, c, &changed);
-                
-                FsRtlExitFileSystem();
-                
                 if (!NT_SUCCESS(Status)) {
                     ERR("balance_metadata_chunk returned %08x\n", Status);
                     Vcb->balance.status = Status;
                     goto end;
                 }
-                
+
                 KeWaitForSingleObject(&Vcb->balance.event, Executive, KernelMode, FALSE, NULL);
-                
+
+                if (Vcb->readonly)
+                    Vcb->balance.stopping = TRUE;
+
                 if (Vcb->balance.stopping)
                     break;
             } while (changed);
-            
-            if (!c->list_entry_changed.Flink)
-                InsertTailList(&Vcb->chunks_changed, &c->list_entry_changed);
+
+            c->changed = TRUE;
+            c->space_changed = TRUE;
         }
-        
-        if (Vcb->balance.stopping) {
-            while (le != &chunks) {
-                c = CONTAINING_RECORD(le, chunk, list_entry_balance);
-                c->reloc = FALSE;
-                
-                le = le->Flink;
-                c->list_entry_balance.Flink = NULL;
-            }
+
+        if (Vcb->balance.stopping)
             break;
-        }
-        
+
         c->list_entry_balance.Flink = NULL;
-        
+
         Vcb->balance.chunks_left--;
     }
-    
+
 end:
     if (!Vcb->readonly) {
-        if (!Vcb->balance.removing) {
-            FsRtlEnterFileSystem();
-            Status = remove_balance_item(Vcb);
-            FsRtlExitFileSystem();
-            
-            if (!NT_SUCCESS(Status)) {
-                ERR("remove_balance_item returned %08x\n", Status);
-                goto end;
+        if (Vcb->balance.stopping || !NT_SUCCESS(Vcb->balance.status)) {
+            le = chunks.Flink;
+            while (le != &chunks) {
+                chunk* c = CONTAINING_RECORD(le, chunk, list_entry_balance);
+                c->reloc = FALSE;
+
+                le = le->Flink;
+                c->list_entry_balance.Flink = NULL;
             }
-        } else {
+
+            if (old_data_flags != 0)
+                Vcb->data_flags = old_data_flags;
+
+            if (old_metadata_flags != 0)
+                Vcb->metadata_flags = old_metadata_flags;
+
+            if (old_system_flags != 0)
+                Vcb->system_flags = old_system_flags;
+        }
+
+        if (Vcb->balance.removing) {
             device* dev = NULL;
-            
-            FsRtlEnterFileSystem();
+
             ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-            
+
             le = Vcb->devices.Flink;
             while (le != &Vcb->devices) {
                 device* dev2 = CONTAINING_RECORD(le, device, list_entry);
-                
+
                 if (dev2->devitem.dev_id == Vcb->balance.opts[0].devid) {
                     dev = dev2;
                     break;
                 }
-                
+
                 le = le->Flink;
             }
-            
+
             if (dev) {
                 if (Vcb->balance.chunks_left == 0) {
                     Status = finish_removing_device(Vcb, dev);
-                    
+
                     if (!NT_SUCCESS(Status)) {
                         ERR("finish_removing_device returned %08x\n", Status);
                         dev->reloc = FALSE;
@@ -2790,15 +3403,94 @@
                 } else
                     dev->reloc = FALSE;
             }
-            
+
             ExReleaseResourceLite(&Vcb->tree_lock);
-            FsRtlExitFileSystem();
+        } else if (Vcb->balance.shrinking) {
+            device* dev = NULL;
+
+            ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
+
+            le = Vcb->devices.Flink;
+            while (le != &Vcb->devices) {
+                device* dev2 = CONTAINING_RECORD(le, device, list_entry);
+
+                if (dev2->devitem.dev_id == Vcb->balance.opts[0].devid) {
+                    dev = dev2;
+                    break;
+                }
+
+                le = le->Flink;
+            }
+
+            if (!dev) {
+                ERR("could not find device %llx\n", Vcb->balance.opts[0].devid);
+                Vcb->balance.status = STATUS_INTERNAL_ERROR;
+            }
+
+            if (Vcb->balance.stopping || !NT_SUCCESS(Vcb->balance.status)) {
+                if (dev) {
+                    Status = regenerate_space_list(Vcb, dev);
+                    if (!NT_SUCCESS(Status))
+                        WARN("regenerate_space_list returned %08x\n", Status);
+                }
+            } else {
+                UINT64 old_size;
+
+                old_size = dev->devitem.num_bytes;
+                dev->devitem.num_bytes = Vcb->balance.opts[0].drange_start;
+
+                Status = update_dev_item(Vcb, dev, NULL);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("update_dev_item returned %08x\n", Status);
+                    dev->devitem.num_bytes = old_size;
+                    Vcb->balance.status = Status;
+
+                    Status = regenerate_space_list(Vcb, dev);
+                    if (!NT_SUCCESS(Status))
+                        WARN("regenerate_space_list returned %08x\n", Status);
+                } else {
+                    Vcb->superblock.total_bytes -= old_size - dev->devitem.num_bytes;
+
+                    Status = do_write(Vcb, NULL);
+                    if (!NT_SUCCESS(Status))
+                        ERR("do_write returned %08x\n", Status);
+
+                    free_trees(Vcb);
+                }
+            }
+
+            ExReleaseResourceLite(&Vcb->tree_lock);
+
+            if (!Vcb->balance.stopping && NT_SUCCESS(Vcb->balance.status))
+                FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_CHANGE_SIZE);
+        } else {
+            Status = remove_balance_item(Vcb);
+            if (!NT_SUCCESS(Status)) {
+                ERR("remove_balance_item returned %08x\n", Status);
+                goto end;
+            }
         }
+
+        if (Vcb->trim && !Vcb->options.no_trim) {
+            ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
+
+            le = Vcb->devices.Flink;
+            while (le != &Vcb->devices) {
+                device* dev2 = CONTAINING_RECORD(le, device, list_entry);
+
+                if (dev2->devobj && !dev2->readonly && dev2->trim)
+                    trim_unalloc_space(Vcb, dev2);
+
+                le = le->Flink;
+            }
+
+            ExReleaseResourceLite(&Vcb->tree_lock);
+        }
     }
-    
+
     ZwClose(Vcb->balance.thread);
     Vcb->balance.thread = NULL;
-    
+
     KeSetEvent(&Vcb->balance.finished, 0, FALSE);
 }
 
@@ -2806,26 +3498,36 @@
     NTSTATUS Status;
     btrfs_start_balance* bsb = (btrfs_start_balance*)data;
     UINT8 i;
-    
+
     if (length < sizeof(btrfs_start_balance) || !data)
         return STATUS_INVALID_PARAMETER;
-    
+
     if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), processor_mode))
         return STATUS_PRIVILEGE_NOT_HELD;
-    
+
+    if (Vcb->locked) {
+        WARN("cannot start balance while locked\n");
+        return STATUS_DEVICE_NOT_READY;
+    }
+
+    if (Vcb->scrub.thread) {
+        WARN("cannot start balance while scrub running\n");
+        return STATUS_DEVICE_NOT_READY;
+    }
+
     if (Vcb->balance.thread) {
         WARN("balance already running\n");
         return STATUS_DEVICE_NOT_READY;
     }
-    
+
     if (Vcb->readonly)
         return STATUS_MEDIA_WRITE_PROTECTED;
-    
+
     if (!(bsb->opts[BALANCE_OPTS_DATA].flags & BTRFS_BALANCE_OPTS_ENABLED) &&
         !(bsb->opts[BALANCE_OPTS_METADATA].flags & BTRFS_BALANCE_OPTS_ENABLED) &&
         !(bsb->opts[BALANCE_OPTS_SYSTEM].flags & BTRFS_BALANCE_OPTS_ENABLED))
         return STATUS_SUCCESS;
-    
+
     for (i = 0; i < 3; i++) {
         if (bsb->opts[i].flags & BTRFS_BALANCE_OPTS_ENABLED) {
             if (bsb->opts[i].flags & BTRFS_BALANCE_OPTS_PROFILES) {
@@ -2835,46 +3537,46 @@
                 if (bsb->opts[i].profiles == 0)
                     return STATUS_INVALID_PARAMETER;
             }
-            
+
             if (bsb->opts[i].flags & BTRFS_BALANCE_OPTS_DEVID) {
                 if (bsb->opts[i].devid == 0)
                     return STATUS_INVALID_PARAMETER;
             }
-            
+
             if (bsb->opts[i].flags & BTRFS_BALANCE_OPTS_DRANGE) {
                 if (bsb->opts[i].drange_start > bsb->opts[i].drange_end)
                     return STATUS_INVALID_PARAMETER;
             }
-            
+
             if (bsb->opts[i].flags & BTRFS_BALANCE_OPTS_VRANGE) {
                 if (bsb->opts[i].vrange_start > bsb->opts[i].vrange_end)
                     return STATUS_INVALID_PARAMETER;
             }
-            
+
             if (bsb->opts[i].flags & BTRFS_BALANCE_OPTS_LIMIT) {
                 bsb->opts[i].limit_start = max(1, bsb->opts[i].limit_start);
                 bsb->opts[i].limit_end = max(1, bsb->opts[i].limit_end);
-                
+
                 if (bsb->opts[i].limit_start > bsb->opts[i].limit_end)
                     return STATUS_INVALID_PARAMETER;
             }
-            
+
             if (bsb->opts[i].flags & BTRFS_BALANCE_OPTS_STRIPES) {
                 bsb->opts[i].stripes_start = max(1, bsb->opts[i].stripes_start);
                 bsb->opts[i].stripes_end = max(1, bsb->opts[i].stripes_end);
-                
+
                 if (bsb->opts[i].stripes_start > bsb->opts[i].stripes_end)
                     return STATUS_INVALID_PARAMETER;
             }
-            
+
             if (bsb->opts[i].flags & BTRFS_BALANCE_OPTS_USAGE) {
                 bsb->opts[i].usage_start = min(100, bsb->opts[i].stripes_start);
                 bsb->opts[i].usage_end = min(100, bsb->opts[i].stripes_end);
-                
+
                 if (bsb->opts[i].stripes_start > bsb->opts[i].stripes_end)
                     return STATUS_INVALID_PARAMETER;
             }
-            
+
             if (bsb->opts[i].flags & BTRFS_BALANCE_OPTS_CONVERT) {
                 if (bsb->opts[i].convert != BLOCK_FLAG_RAID0 && bsb->opts[i].convert != BLOCK_FLAG_RAID1 &&
                     bsb->opts[i].convert != BLOCK_FLAG_DUPLICATE && bsb->opts[i].convert != BLOCK_FLAG_RAID10 &&
@@ -2884,79 +3586,77 @@
             }
         }
     }
-    
+
     RtlCopyMemory(&Vcb->balance.opts[BALANCE_OPTS_DATA], &bsb->opts[BALANCE_OPTS_DATA], sizeof(btrfs_balance_opts));
     RtlCopyMemory(&Vcb->balance.opts[BALANCE_OPTS_METADATA], &bsb->opts[BALANCE_OPTS_METADATA], sizeof(btrfs_balance_opts));
     RtlCopyMemory(&Vcb->balance.opts[BALANCE_OPTS_SYSTEM], &bsb->opts[BALANCE_OPTS_SYSTEM], sizeof(btrfs_balance_opts));
-    
+
     Vcb->balance.paused = FALSE;
     Vcb->balance.removing = FALSE;
+    Vcb->balance.shrinking = FALSE;
     Vcb->balance.status = STATUS_SUCCESS;
     KeInitializeEvent(&Vcb->balance.event, NotificationEvent, !Vcb->balance.paused);
-    
+
     Status = PsCreateSystemThread(&Vcb->balance.thread, 0, NULL, NULL, NULL, balance_thread, Vcb);
     if (!NT_SUCCESS(Status)) {
         ERR("PsCreateSystemThread returned %08x\n", Status);
         return Status;
     }
-    
+
     return STATUS_SUCCESS;
 }
 
-NTSTATUS look_for_balance_item(device_extension* Vcb) {
-    LIST_ENTRY rollback;
+NTSTATUS look_for_balance_item(_Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb) {
     KEY searchkey;
     traverse_ptr tp;
     NTSTATUS Status;
     BALANCE_ITEM* bi;
     int i;
-    
-    InitializeListHead(&rollback);
-    
+
     searchkey.obj_id = BALANCE_ITEM_ID;
     searchkey.obj_type = TYPE_TEMP_ITEM;
     searchkey.offset = 0;
-    
+
     Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("find_item returned %08x\n", Status);
         return Status;
     }
-    
+
     if (keycmp(tp.item->key, searchkey)) {
         TRACE("no balance item found\n");
         return STATUS_NOT_FOUND;
     }
-    
+
     if (tp.item->size < sizeof(BALANCE_ITEM)) {
         WARN("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset,
              tp.item->size, sizeof(BALANCE_ITEM));
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     bi = (BALANCE_ITEM*)tp.item->data;
-    
+
     if (bi->flags & BALANCE_FLAGS_DATA)
         load_balance_args(&Vcb->balance.opts[BALANCE_OPTS_DATA], &bi->data);
-    
+
     if (bi->flags & BALANCE_FLAGS_METADATA)
         load_balance_args(&Vcb->balance.opts[BALANCE_OPTS_METADATA], &bi->metadata);
-    
+
     if (bi->flags & BALANCE_FLAGS_SYSTEM)
         load_balance_args(&Vcb->balance.opts[BALANCE_OPTS_SYSTEM], &bi->system);
-    
+
     // do the heuristics that Linux driver does
-    
+
     for (i = 0; i < 3; i++) {
         if (Vcb->balance.opts[i].flags & BTRFS_BALANCE_OPTS_ENABLED) {
             // if converting, don't redo chunks already done
-            
+
             if (Vcb->balance.opts[i].flags & BTRFS_BALANCE_OPTS_CONVERT)
                 Vcb->balance.opts[i].flags |= BTRFS_BALANCE_OPTS_SOFT;
-            
+
             // don't balance chunks more than 90% filled - presumably these
             // have already been done
-            
+
             if (!(Vcb->balance.opts[i].flags & BTRFS_BALANCE_OPTS_USAGE) &&
                 !(Vcb->balance.opts[i].flags & BTRFS_BALANCE_OPTS_CONVERT)
             ) {
@@ -2966,50 +3666,54 @@
             }
         }
     }
-    
+
     if (Vcb->readonly || Vcb->options.skip_balance)
         Vcb->balance.paused = TRUE;
     else
         Vcb->balance.paused = FALSE;
-    
+
     Vcb->balance.removing = FALSE;
+    Vcb->balance.shrinking = FALSE;
     Vcb->balance.status = STATUS_SUCCESS;
     KeInitializeEvent(&Vcb->balance.event, NotificationEvent, !Vcb->balance.paused);
-    
+
     Status = PsCreateSystemThread(&Vcb->balance.thread, 0, NULL, NULL, NULL, balance_thread, Vcb);
     if (!NT_SUCCESS(Status)) {
         ERR("PsCreateSystemThread returned %08x\n", Status);
         return Status;
     }
-    
+
     return STATUS_SUCCESS;
 }
 
 NTSTATUS query_balance(device_extension* Vcb, void* data, ULONG length) {
     btrfs_query_balance* bqb = (btrfs_query_balance*)data;
-    
+
     if (length < sizeof(btrfs_query_balance) || !data)
         return STATUS_INVALID_PARAMETER;
-    
+
     if (!Vcb->balance.thread) {
         bqb->status = BTRFS_BALANCE_STOPPED;
-        
+
         if (!NT_SUCCESS(Vcb->balance.status)) {
             bqb->status |= BTRFS_BALANCE_ERROR;
             bqb->error = Vcb->balance.status;
         }
-        
+
         return STATUS_SUCCESS;
     }
-    
+
     bqb->status = Vcb->balance.paused ? BTRFS_BALANCE_PAUSED : BTRFS_BALANCE_RUNNING;
-    
+
     if (Vcb->balance.removing)
         bqb->status |= BTRFS_BALANCE_REMOVAL;
-    
+
+    if (Vcb->balance.shrinking)
+        bqb->status |= BTRFS_BALANCE_SHRINKING;
+
     if (!NT_SUCCESS(Vcb->balance.status))
         bqb->status |= BTRFS_BALANCE_ERROR;
-    
+
     bqb->chunks_left = Vcb->balance.chunks_left;
     bqb->total_chunks = Vcb->balance.total_chunks;
     bqb->error = Vcb->balance.status;
@@ -3023,16 +3727,16 @@
 NTSTATUS pause_balance(device_extension* Vcb, KPROCESSOR_MODE processor_mode) {
     if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), processor_mode))
         return STATUS_PRIVILEGE_NOT_HELD;
-    
+
     if (!Vcb->balance.thread)
         return STATUS_DEVICE_NOT_READY;
-    
+
     if (Vcb->balance.paused)
         return STATUS_DEVICE_NOT_READY;
-    
+
     Vcb->balance.paused = TRUE;
     KeClearEvent(&Vcb->balance.event);
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -3039,19 +3743,19 @@
 NTSTATUS resume_balance(device_extension* Vcb, KPROCESSOR_MODE processor_mode) {
     if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), processor_mode))
         return STATUS_PRIVILEGE_NOT_HELD;
-    
+
     if (!Vcb->balance.thread)
         return STATUS_DEVICE_NOT_READY;
-    
+
     if (!Vcb->balance.paused)
         return STATUS_DEVICE_NOT_READY;
-    
+
     if (Vcb->readonly)
         return STATUS_MEDIA_WRITE_PROTECTED;
-    
+
     Vcb->balance.paused = FALSE;
     KeSetEvent(&Vcb->balance.event, 0, FALSE);
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -3058,16 +3762,15 @@
 NTSTATUS stop_balance(device_extension* Vcb, KPROCESSOR_MODE processor_mode) {
     if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), processor_mode))
         return STATUS_PRIVILEGE_NOT_HELD;
-    
+
     if (!Vcb->balance.thread)
         return STATUS_DEVICE_NOT_READY;
-    
+
     Vcb->balance.paused = FALSE;
     Vcb->balance.stopping = TRUE;
-    Vcb->balance.cancelling = TRUE;
     Vcb->balance.status = STATUS_SUCCESS;
     KeSetEvent(&Vcb->balance.event, 0, FALSE);
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -3078,45 +3781,45 @@
     NTSTATUS Status;
     int i;
     UINT64 num_rw_devices;
-    
+
     TRACE("(%p, %p, %x)\n", Vcb, data, length);
-    
+
     if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), processor_mode))
         return STATUS_PRIVILEGE_NOT_HELD;
-    
+
     if (length < sizeof(UINT64))
         return STATUS_INVALID_PARAMETER;
-    
+
     devid = *(UINT64*)data;
-    
+
     ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
-    
+
     if (Vcb->readonly) {
         ExReleaseResourceLite(&Vcb->tree_lock);
         return STATUS_MEDIA_WRITE_PROTECTED;
     }
-    
+
     num_rw_devices = 0;
-    
+
     le = Vcb->devices.Flink;
     while (le != &Vcb->devices) {
         device* dev2 = CONTAINING_RECORD(le, device, list_entry);
-        
+
         if (dev2->devitem.dev_id == devid)
             dev = dev2;
-        
+
         if (!dev2->readonly)
             num_rw_devices++;
-        
+
         le = le->Flink;
     }
-    
+
     if (!dev) {
         ExReleaseResourceLite(&Vcb->tree_lock);
         WARN("device %llx not found\n", devid);
         return STATUS_NOT_FOUND;
     }
-    
+
     if (!dev->readonly) {
         if (num_rw_devices == 1) {
             ExReleaseResourceLite(&Vcb->tree_lock);
@@ -3123,7 +3826,7 @@
             WARN("not removing last non-readonly device\n");
             return STATUS_INVALID_PARAMETER;
         }
-        
+
         if (num_rw_devices == 4 &&
             ((Vcb->data_flags & BLOCK_FLAG_RAID10 || Vcb->metadata_flags & BLOCK_FLAG_RAID10 || Vcb->system_flags & BLOCK_FLAG_RAID10) ||
              (Vcb->data_flags & BLOCK_FLAG_RAID6 || Vcb->metadata_flags & BLOCK_FLAG_RAID6 || Vcb->system_flags & BLOCK_FLAG_RAID6))
@@ -3132,13 +3835,13 @@
             ERR("would not be enough devices to satisfy RAID requirement (RAID6/10)\n");
             return STATUS_CANNOT_DELETE;
         }
-        
+
         if (num_rw_devices == 3 && (Vcb->data_flags & BLOCK_FLAG_RAID5 || Vcb->metadata_flags & BLOCK_FLAG_RAID5 || Vcb->system_flags & BLOCK_FLAG_RAID5)) {
             ExReleaseResourceLite(&Vcb->tree_lock);
             ERR("would not be enough devices to satisfy RAID requirement (RAID5)\n");
             return STATUS_CANNOT_DELETE;
         }
-        
+
         if (num_rw_devices == 2 &&
             ((Vcb->data_flags & BLOCK_FLAG_RAID0 || Vcb->metadata_flags & BLOCK_FLAG_RAID0 || Vcb->system_flags & BLOCK_FLAG_RAID0) ||
              (Vcb->data_flags & BLOCK_FLAG_RAID1 || Vcb->metadata_flags & BLOCK_FLAG_RAID1 || Vcb->system_flags & BLOCK_FLAG_RAID1))
@@ -3148,27 +3851,29 @@
             return STATUS_CANNOT_DELETE;
         }
     }
-    
+
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     if (Vcb->balance.thread) {
         WARN("balance already running\n");
         return STATUS_DEVICE_NOT_READY;
     }
-    
+
     dev->reloc = TRUE;
-    
+
     RtlZeroMemory(Vcb->balance.opts, sizeof(btrfs_balance_opts) * 3);
-    
+
     for (i = 0; i < 3; i++) {
         Vcb->balance.opts[i].flags = BTRFS_BALANCE_OPTS_ENABLED | BTRFS_BALANCE_OPTS_DEVID;
         Vcb->balance.opts[i].devid = devid;
     }
-    
+
     Vcb->balance.paused = FALSE;
     Vcb->balance.removing = TRUE;
+    Vcb->balance.shrinking = FALSE;
+    Vcb->balance.status = STATUS_SUCCESS;
     KeInitializeEvent(&Vcb->balance.event, NotificationEvent, !Vcb->balance.paused);
-    
+
     Status = PsCreateSystemThread(&Vcb->balance.thread, 0, NULL, NULL, NULL, balance_thread, Vcb);
     if (!NT_SUCCESS(Status)) {
         ERR("PsCreateSystemThread returned %08x\n", Status);
@@ -3175,6 +3880,6 @@
         dev->reloc = FALSE;
         return Status;
     }
-    
+
     return STATUS_SUCCESS;
 }
